Package org.apache.catalina.tribes.membership.cloud

## Class AbstractStreamProvider

- java.lang.Object
- - org.apache.catalina.tribes.membership.cloud.AbstractStreamProvider

All Implemented Interfaces:
  `StreamProvider`

Direct Known Subclasses:
  `CertificateStreamProvider`, `InsecureStreamProvider`, `TokenStreamProvider`

    public abstract class AbstractStreamProvider
    extends java.lang.Object
    implements StreamProvider

### Field Summary

Fields
`protected static javax.net.ssl.TrustManager[]` `INSECURE_TRUST_MANAGERS`
`protected static StringManager` `sm`

### Constructor Summary

Constructors
`AbstractStreamProvider()`

### Method Summary

All Methods Static Methods Instance Methods Abstract Methods Concrete Methods
`protected static javax.net.ssl.TrustManager[]` `configureCaCert​(java.lang.String caCertFile)`
`protected abstract javax.net.ssl.SSLSocketFactory` `getSocketFactory()`
`java.net.URLConnection` `openConnection​(java.lang.String url, java.util.Map<java.lang.String,​java.lang.String> headers, int connectTimeout, int readTimeout)` Open URL connection to the specified URL.
`java.io.InputStream` `openStream​(java.lang.String url, java.util.Map<java.lang.String,​java.lang.String> headers, int connectTimeout, int readTimeout)` Open stream to the specified URL.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### sm

    protected static final StringManager sm

#### INSECURE_TRUST_MANAGERS

    protected static final javax.net.ssl.TrustManager[] INSECURE_TRUST_MANAGERS

### Constructor Detail

#### AbstractStreamProvider

    public AbstractStreamProvider()

### Method Detail

#### getSocketFactory

    protected abstract javax.net.ssl.SSLSocketFactory getSocketFactory()

Returns:
  the socket factory, or null if not needed

#### openConnection

    public java.net.URLConnection openConnection​(java.lang.String url,
                                                 java.util.Map<java.lang.String,​java.lang.String> headers,
                                                 int connectTimeout,
                                                 int readTimeout)
                                          throws java.io.IOException

Open URL connection to the specified URL.

Parameters:
  `url` - the url
  `headers` - the headers map
  `connectTimeout` - connection timeout in ms
  `readTimeout` - read timeout in ms
Returns:
  the URL connection
Throws:
  `java.io.IOException` - when an error occurs

#### openStream

    public java.io.InputStream openStream​(java.lang.String url,
                                          java.util.Map<java.lang.String,​java.lang.String> headers,
                                          int connectTimeout,
                                          int readTimeout)
                                   throws java.io.IOException

Description copied from interface: `StreamProvider`
Open stream to the specified URL.

Specified by:
  `openStream` in interface `StreamProvider`
Parameters:
  `url` - the url
  `headers` - the headers map
  `connectTimeout` - connection timeout in ms
  `readTimeout` - read timeout in ms
Returns:
  the stream
Throws:
  `java.io.IOException` - when an error occurs

#### configureCaCert

    protected static javax.net.ssl.TrustManager[] configureCaCert​(java.lang.String caCertFile)
                                                           throws java.lang.Exception

Throws:
  `java.lang.Exception`